// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#pragma comment(lib, "Winmm.lib") 
#include "stdafx.h"
#include "Windows.h"

#include <iostream>
#include <time.h>

/** a signed 64-bit integer value type */
#define _INT64 __int64

/** a signed 32-bit integer value type */
#define _INT32 __int32

/** a signed 16-bit integer value type */
#define _INT16 __int16

/** a signed 8-bit integer value type */
#define _INT8 __int8

/** an unsigned 64-bit integer value type */
#define _UINT64 unsigned _INT64

/** an unsigned 32-bit integer value type */
#define _UINT32 unsigned _INT32

/** an unsigned 16-bit integer value type */
#define _UINT16 unsigned _INT16

/** an unsigned 8-bit integer value type */
#define _UINT8 unsigned _INT8

/** Use to init the clock */
#define TIMER_INIT LARGE_INTEGER frequency;LARGE_INTEGER t1, t2;double elapsedTime;QueryPerformanceFrequency(&frequency);

/** Use to start the performance timer */
#define TIMER_START QueryPerformanceCounter(&t1);

/** Use to stop the performance timer and output the result to the standard stream. Less verbose than \c TIMER_STOP_VERBOSE */
#define TIMER_STOP QueryPerformanceCounter(&t2);elapsedTime=(t2.QuadPart-t1.QuadPart)*1000.0/frequency.QuadPart;std::wcout<<elapsedTime<<L" ms."<<std::endl;

// SSE2 optimized memcpy()
void *MemCpySse2(void *__restrict b, const void *__restrict a, size_t n)
{
    char *s1 = (char*)b;
    const char *s2 = (const char*)a;
    for(; 0<n; --n)*s1++ = *s2++;
    return b;
}

// General memcpy
void *MemCpy(void *dest, const void *source, size_t count)
{
	size_t blockIdx;
	size_t blocks = count >> 3;
	size_t bytesLeft = count - (blocks << 3);

	// Copy 64-bit blocks first
	_UINT64 *sourcePtr8 = (_UINT64*)source;
	_UINT64 *destPtr8 = (_UINT64*)dest;
 	for (blockIdx = 0; blockIdx < blocks; blockIdx++) destPtr8[blockIdx] = sourcePtr8[blockIdx];

	if (!bytesLeft) return dest;

	blocks = bytesLeft >> 2;
	bytesLeft = bytesLeft - (blocks << 2);

	// Copy 32-bit blocks
	_UINT32 *sourcePtr4 = (_UINT32*)&sourcePtr8[blockIdx];
	_UINT32 *destPtr4 = (_UINT32*)&destPtr8[blockIdx];
	for (blockIdx = 0; blockIdx < blocks; blockIdx++) destPtr4[blockIdx] = sourcePtr4[blockIdx];

	if (!bytesLeft) return dest;

	blocks = bytesLeft >> 1;
	bytesLeft = bytesLeft - (blocks << 1);

	// Copy 16-bit blocks
	_UINT16 *sourcePtr2 = (_UINT16*)&sourcePtr4[blockIdx];
	_UINT16 *destPtr2 = (_UINT16*)&destPtr4[blockIdx];
	for (blockIdx = 0; blockIdx < blocks; blockIdx++) destPtr2[blockIdx] = sourcePtr2[blockIdx];

	if (!bytesLeft) return dest;

	// Copy byte blocks
	_UINT8 *sourcePtr1 = (_UINT8*)&sourcePtr2[blockIdx];
	_UINT8 *destPtr1 = (_UINT8*)&destPtr2[blockIdx];
	for (blockIdx = 0; blockIdx < bytesLeft; blockIdx++) destPtr1[blockIdx] = sourcePtr1[blockIdx];
	return dest;
}

int _tmain(int argc, _TCHAR* argv[])
{
    TIMER_INIT

    const int n = 100000;

	char *src = new char[n];
	char *dst = new char[n];

    {
        std::cout << "memcpy() took:" << std::endl;
        TIMER_START;

        for (int i = 0; i < n ; i ++)
			memcpy((void*)dst, (const void*)src, (size_t)i);

        TIMER_STOP;
    }
    {
       std::cout << "MemCpy() took:" << std::endl;

        TIMER_START;

        for (int i = 0; i < n ; i ++)
			MemCpy((void*)dst, (const void*)src, (size_t)i);

		TIMER_STOP;
    }
    {
       std::cout << "MemCpySse2() took:" << std::endl;

        TIMER_START;

        for (int i = 0; i < n ; i ++)
			MemCpySse2((void*)dst, (const void*)src, (size_t)i);

		TIMER_STOP;
    }

	delete [] src;
	delete [] dst;

    std::cout << "Done" << std::endl;
    int wait = getchar();
    return 0;
}

